################################################################################
# TCL FILE #
#
# System:  " -31"
# Machine: "16K20T1" + ""
# Type: LATHE
# version 2. (12/12/2001)
# Russia, KnAAPO,OGT,SPC(Sector of the Program Control #"  ")
#  : Rodionova Elena.
################################################################################
#
# 10-11 --2002  	 Rodionova Elena         0. Original
# 24.06.2002     	 Rodionova Elena         1.    
#                                                2.
#                                                3.
#                                                4.
################################################################################
  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir  [MOM_ask_env_var UGII_CAM_DEBUG_DIR]

  if { ![info exists mom_sys_post_initialized] } {

     source ${cam_post_dir}ugpost_base.tcl

     proc MOM_before_each_add_var {} {}
     proc MOM_before_each_event {} {}

     set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]
#     source ${cam_debug_dir}mom_debug.tcl
#     source ${cam_debug_dir}mom_review.tcl

     MOM_set_debug_mode OFF


   ####  Listing File variables
     set mom_sys_list_output                       "ON"
     set mom_sys_header_output                     "ON"
     set mom_sys_list_file_rows                    "120"
     set mom_sys_list_file_columns                 "150"
     set mom_sys_warning_output                    "ON"
     set mom_sys_group_output                      "OFF"
     set mom_sys_list_file_suffix                  "lpt"
     set mom_list_file_suffix              	   "lpt"
     set mom_sys_output_file_suffix                "ptp"
     set mom_output_file_suffix                	   "up"
     set mom_sys_commentary_output                 "ON"
     set mom_sys_commentary_list                   "x z feed speed"

     set mom_sys_control_out                       ""
     set mom_sys_control_in                        ""

     set mom_sys_post_initialized 1
  }

 global TIME
 set TIME 0.0

################################################################################

#======================   
 set Pos(0) 0 ; set Pos(1) 0 ; set Pos(2) 0
 set tx 0.0 ; set tz 0.0;
 set pb_start_of_program 0
 set rad2deg [expr 90.0 / asin(1.0)]
 set var_start_of_path_num    0   ; #   
 set first_tool               0   ; #  1- 
 set change_tool_feed		0 ;

global MINRPx MINRPz MAXRPx MAXRPz
set MINRPx  0
set MINRPz  0
set MAXRPx  2000
set MAXRPz  2000

set  typeCmove      "none" ;
set  flagCutcom       0    ;
set  cycle_name     "NONE" ;
set  dwell_output     0    ;
set  G4               ""   ;
set  P4               ""   ;
set  output_G97       0    ; # G97

#
set spindle_minimum_rpm        0.0 ;
set output_mode                  0 ;
set var_rapid_move_condition     1 ; # 1 -    [(~)X* Z]; 2 - [(~)Z (~)X];

set MINRPx 2.8 ;
set MINRPz 1.4 ;
set MAXRPx 2000 ;
set MAXRPz 1000 ;

set TextIncr                  "#"  ; # 
set TextLdr                   "~"  ;
set Textp45                  "+45" ;
set Textm45                  "-45" ;
set TextTrlr                  "*"  ;
set Text_cycle_synch          "#"  ;
set TypeFunction             "61"  ;

# G92 =
# 
#-     
#+     

########## (Global variables definded and Initialised)################
#
  set mom_sys_rapid_code                      "0"
  set mom_sys_linear_code                     "1"
  set mom_sys_circle_code(CLW)                "3"
  set mom_sys_circle_code(CCLW)               "2"
  set mom_sys_lathe_thread_advance_type(1)    32
  set mom_sys_cycle_tap_code                  33
#
  set mom_sys_delay_code(SECONDS)           "4"
  set mom_sys_delay_code(REVOLUTIONS)       "4"
  set mom_sys_delay_code(SLOWDN)            "9"
  set mom_sys_reset_code                    "92"
  set mom_sys_feed_rate_mode_code(IPM)      "94"
  set mom_sys_feed_rate_mode_code(IPR)      "95"
  set mom_sys_feed_rate_mode_code(FRN)      "93"
  set mom_sys_feed_rate_mode_code(MMPM)     "94"
  set mom_sys_feed_rate_mode_code(MMPR)     "95"
  set mom_sys_feed_rate_mode_code(FRN)      "93"
  set mom_sys_spindle_mode_code(SFM)        "96"
  set mom_sys_spindle_mode_code(RPM)        "97"
  set mom_sys_spindle_mode_code(SMM)        "96"
#
  set mom_sys_program_stop_code                0
  set mom_sys_optional_stop_code               1
  set mom_sys_end_of_program_code              2
  set mom_sys_tool_change_code                 6
  set mom_sys_spindle_direction_code(NONE)     3
  set mom_sys_spindle_direction_code(CLW)      3
  set mom_sys_spindle_direction_code(CCLW)     4
  set mom_sys_spindle_direction_code(OFF)      5
  set mom_sys_spindle_direction_code(ORIENT)   19
  set mom_sys_coolant_code(MIST)               7
  set mom_sys_coolant_code(FLOOD)              8
  set mom_sys_coolant_code(TAP)                8
  set mom_sys_coolant_code(ON)                 8
  set mom_sys_coolant_code(OFF)                9
  set mom_sys_rewind_code                     30
#
  set mom_sys_spindle_ranges                   5
  set mom_sys_spindle_range_code(0)           40
  set mom_sys_spindle_range_code(1)           41
  set mom_sys_spindle_range_code(2)           42
  set mom_sys_spindle_range_code(3)           43
  set mom_sys_spindle_range_code(4)           44
  set mom_sys_spindle_range_code(40)          40
  set mom_sys_spindle_range_code(41)          41
  set mom_sys_spindle_range_code(42)          42
  set mom_sys_spindle_range_code(43)          43
  set mom_sys_spindle_range_code(44)          44
   set mom_sys_spindle_param(1,min)             "20"
   set mom_sys_spindle_param(1,max)             "400"
   set mom_sys_spindle_param(2,min)             "125"
   set mom_sys_spindle_param(2,max)             "2500"
#
  set mom_sys_cycle_tap_code                  33
  set mom_sys_cycle_breakchip_code            73
  set mom_sys_cycle_drill_code                72
  set mom_sys_cycle_drill_deep_code           73 ; #72  73
#
  set mom_sys_rewind_stop_code                  "%"
  set mom_sys_home_pos(0)                       "0"
  set mom_sys_home_pos(1)                       "0"
  set mom_sys_home_pos(2)                       "0"
  set mom_sys_zero                              "0"
  set mom_sys_opskip_block_leader               ""
  set mom_sys_seqnum_start                      "1"
  set mom_sys_seqnum_incr                       "1"
  set mom_sys_seqnum_freq                       "1"
  set mom_sys_leader(N)                       	N ; #"" ;#N
#
  set mom_sys_reset_code                        "92"
  set mom_sys_feed_rate_mode_code(IPM)          "94"
  set mom_sys_feed_rate_mode_code(IPR)          "95"
  set mom_sys_feed_rate_mode_code(FRN)          "93"
  set mom_sys_return_code                       "28"
  set mom_sys_feed_rate_mode_code(MMPM)         "94"
  set mom_sys_feed_rate_mode_code(MMPR)         "95"
  set mom_sys_spindle_mode_code(SFM)            "96"
  set mom_sys_spindle_mode_code(SMM)            "96"
  set mom_sys_spindle_mode_code(RPM)            "97"
#
  set mom_sys_cycle_feed_mode                   "MMPM"
  set mom_sys_contour_feed_mode(LINEAR)         "MMPM"
  set mom_sys_contour_feed_mode(ROTARY)         "MMPM"
  set mom_sys_contour_feed_mode(LINEAR_ROTARY)  "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR)           "MMPM"
  set mom_sys_rapid_feed_mode(ROTARY)           "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR_ROTARY)    "MMPM"
#
  set mom_sys_feed_param(IPM,format)         "Feed_IPM"
  set mom_sys_feed_param(IPR,format)         "Feed_IPR"
  set mom_sys_feed_param(FRN,format)         "Feed_INV"
  set mom_sys_feed_param(MMPM,format)        "Feed_MMPM"
  set mom_sys_feed_param(MMPR,format)        "Feed_MMPR"
  set mom_sys_feed_param(FRN,format)         "Feed_INV"
#
  set mom_sys_delay_param(SECONDS,format)     "Dwell_SECONDS"
  set mom_sys_delay_param(REVOLUTIONS,format) "Dwell_REVOLUTIONS"
#
  set mom_sys_delay_output_mode              "SECONDS"
  set mom_sys_gcodes_per_block               1
  set mom_sys_mcodes_per_block               1

  set mom_sys_lathe_i_double                    "1"  
  set mom_sys_lathe_x_factor                    "2" 
  set mom_sys_lathe_y_factor                    "1"  
  set mom_sys_lathe_z_factor                    "1"


####### KINEMATIC VARIABLE DECLARATIONS ##############
  set mom_kin_arc_output_mode                   "QUADRANT"  ;   #QUADRANT   LINEAR  FULL_CIRCLE
  set mom_kin_arc_valid_plane                   "XY" ;  #XY XZ XYZ  ANY
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_linearization_flag                "F"
  set mom_kin_linearization_tol                 "0.01"
  set mom_kin_machine_resolution                "0.01"
  set mom_kin_machine_type                      "lathe"
  set mom_kin_min_arc_length                    "0.01"
  set mom_kin_min_arc_radius                    "0.1" ; # 0.2 0.01
  set mom_kin_max_arc_radius                    "999.99"
  set mom_kin_max_fpr                           "9999.99"
  set mom_kin_max_fpm                           "9999.99"
  set mom_kin_max_frn                           "9999.99"
  set mom_kin_min_fpm                           "0.01"
  set mom_kin_min_frn                           "0.0"
  set mom_kin_min_fpr                           "0.01"
  set mom_kin_output_unit                       "MM"
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_ind_to_dependent_head_x           "0.0"
  set mom_kin_ind_to_dependent_head_z           "0.0"
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "9999.99"
  set mom_kin_tool_change_time                  "12.0"
  set mom_kin_x_axis_limit                      "9999.99"
  set mom_kin_y_axis_limit                      "0.0"
  set mom_kin_z_axis_limit                      "9999.99"
  set mom_kin_coordinate_type                   "CARTESIAN"
;#  set mom_kin_read_ahead_next_motion            "1" ;


################################################################################

#=============================================================
proc  MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type
  global mom_progammed_feed_rate
  global  mom_ref_pos  mom_pos
  global  mom_pos_arc_center  mom_ref_pos_arc_center
  global  mom_from_pos  mom_from_ref_pos
  global  mom_gohome_pos  mom_gohome_ref_pos
  FEEDRATE_SET
  set mom_pos(0) $mom_ref_pos(0); set mom_pos(1) $mom_ref_pos(1); set mom_pos(2) $mom_ref_pos(2);

  switch $mom_motion_event {
    circular_move {
      if {[hiset mom_ref_pos_arc_center(0)]} {set mom_pos_arc_center(0) $mom_ref_pos_arc_center(0)}
      if {[hiset mom_ref_pos_arc_center(1)]} {set mom_pos_arc_center(1) $mom_ref_pos_arc_center(1)}
      if {[hiset mom_ref_pos_arc_center(2)]} {set mom_pos_arc_center(2) $mom_ref_pos_arc_center(2)}
    }
    from_move {
      if {[hiset mom_from_ref_pos(0)]} {set mom_from_pos(0) $mom_from_ref_pos(0)}
      if {[hiset mom_from_ref_pos(1)]} {set mom_from_pos(1) $mom_from_ref_pos(1)}
      if {[hiset mom_from_ref_pos(2)]} {set mom_from_pos(2) $mom_from_ref_pos(2)}
    }
    gohome_move {
      if {[hiset mom_gohome_ref_pos(0)]} {set mom_gohome_pos(0) $mom_gohome_ref_pos(0)}
      if {[hiset mom_gohome_ref_pos(1)]} {set mom_gohome_pos(1) $mom_gohome_ref_pos(1)}
      if {[hiset mom_gohome_ref_pos(2)]} {set mom_gohome_pos(2) $mom_gohome_ref_pos(2)}
    }
  }

  switch $mom_motion_type {
    LINEAR    {PB_linear_event}
    FIRSTCUT  {PB_linear_event}
    RAPID    {PB_rapid_event}
    TRAVERSAL {PB_traversal_event}
    ENGAGE    {PB_engage_event}
    APPROACH  {PB_approach_event}
    CUT      {PB_cut_event}
    RETURN   { ; }
  }

    if [llength [info commands PB_CMD_kin_before_motion] ] { PB_CMD_kin_before_motion }
    if [llength [info commands PB_CMD_before_motion] ]     { PB_CMD_before_motion }

}

#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================
  global mom_motion_distance
  global feed f_pm
  global com_feed_rate
  global mom_kin_rapid_feed_rate

 global mom_motion_type
 if {$mom_motion_type == "GOHOME"} { set com_feed_rate 0.0 ; }

 #_time_eq
  global TIME
  if {[EQ_is_zero $com_feed_rate]} { set com_feed_rate $mom_kin_rapid_feed_rate }
  set TIME [ expr ($TIME+$mom_motion_distance/$com_feed_rate) ]

}


#=============================================================
proc PB_linear_event {} { ; }
proc PB_linear_event {} { ; }
proc PB_rapid_event {} { ; }
proc PB_traversal_event {} { ; }
proc PB_engage_event {} { ; }
proc PB_approach_event {} { ; }
proc PB_cut_event {} { ; }
#=============================================================
proc PB_return_event {} {
#=============================================================
 global mom_programmed_feed_rate  mom_feed_rate  mom_kin_rapid_feed_rate

 global mom_motion_type
 if {$mom_motion_type == "GOHOME"} { MOM_rapid_move; return ;}

 if {$mom_programmed_feed_rate == 0.0 || $mom_feed_rate >= $mom_kin_rapid_feed_rate  } {
  	MOM_rapid_move ; return ;
  } else { MOM_linear_move ; return ; }

}

#=============================================================
proc PB_feed { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev
  global mom_kin_rapid_feed_rate  mom_kin_max_fpm
  global mom_programmed_feed_rate  feed

  global prev_feed_rate_mode    mom_feed_rate_mode  feed_mode

  global change_tool_feed
  if {$change_tool_feed==1} {
    set change_tool_feed 0
    catch { unset prev_feed_rate_mode }
    MOM_force once F
  }

  switch $feed_mode {
    IPM     -
    MMPM    -
    IPR     -
    MMPR    -
    DPM     -
    FRN     -
    INVERSE { ; }
    default { set feed_mode "MMPR" ; }
  }

  if {[isset prev_feed_rate_mode] == "n"} {
          set prev_feed_rate_mode $mom_feed_rate_mode
          MOM_force once G_feed
      } elseif {$prev_feed_rate_mode != $mom_feed_rate_mode} {
          set prev_feed_rate_mode $mom_feed_rate_mode
          MOM_force once G_feed
      } else {  MOM_suppress once G_feed ; }

  set _tmp  [expr $mom_programmed_feed_rate*100.0]
  if {[ EQ_is_gt $_tmp 9999.99 ] } { set feed $mom_programmed_feed_rate ; } else { set feed  $_tmp ; }

  MOM_do_template feed_G
  MOM_do_template oneF

}

#=============================================================
proc PB_condition_move {} {
#=============================================================
  global mom_motion_event mom_motion_type
  global mom_feed_rate  mom_feed_rate_mode  mom_feed_rate_per_rev
  global mom_kin_max_fpm  mom_kin_rapid_feed_rate
  global mom_programmed_feed_rate feed

  if {[info exists mom_kin_rapid_feed_rate] != 0} {
    if { ( $mom_feed_rate >= $mom_kin_rapid_feed_rate ) || ( $feed >= $mom_kin_rapid_feed_rate ) }  { MOM_rapid_move ; return }
    if { ($mom_programmed_feed_rate !=0) && ($mom_programmed_feed_rate < $mom_kin_rapid_feed_rate) } {MOM_linear_move; return }
  }
  if {$mom_motion_event == "rapid_move"} {  MOM_rapid_move ; return  } else {MOM_linear_move; return  }
  if {$mom_motion_type == "RAPID"} {MOM_rapid_move} else {MOM_linear_move}

}

############################### CYCLE LATHE #######################

#=============================================================
proc MOM_thread { } {
#=============================================================
}

set lathe_num_cut 0;

#=============================================================
proc MOM_thread_move { } {
#=============================================================
#  global lathe_num_cut ; incr lathe_num_cut;
#  if {$lathe_num_cut==3} {
#	global mom_kin_rapid_feed_rate   mom_feed_rate   feed  mom_programmed_feed_rate
#  	if {$mom_programmed_feed_rate == 0.0 || $mom_feed_rate >= $mom_kin_rapid_feed_rate } {
#     		MOM_suppress Once F  G_feed
#    	}
#    ;#PB_feed
#  MOM_suppress ALWAYS  Text_ldr   Text_m45   Text_p45  X  Z   Text_incr   Text_trlr
#  MOM_force once G ;
#  MOM_do_template cycle_thread_move_G
#  MOM_force ONCE X Text_trlr;
#  MOM_do_template thread_move_X
#  MOM_force ONCE Z Text_trlr;
#  MOM_do_template thread_move_Z
#  MOM_force ONCE  StepThreadF  ;
#  MOM_do_template  thread_move_F
#
#  global mom_lathe_thread_value  mom_turn_thread_pitch_lead
##MOM_output_literal " $mom_lathe_thread_value=$mom_turn_thread_pitch_lead"
#
#  global mom_prev_pos mom_pos
#  global varP3
#  set  varP3 [expr {$mom_pos(0)==$mom_prev_pos(0) ?0: [ expr ($mom_pos(0)-$mom_prev_pos(0))] } ]
#  set varP3 0.0
#
#  MOM_force ONCE I
#  MOM_do_template thread_move_P1
#  MOM_force ONCE K
#  MOM_do_template thread_move_P2
#
#  global mom_turn_thread_crest_line
##MOM_output_literal "X=$mom_pos(0) Z=$mom_pos(2)"
##MOM_output_literal "X=$mom_prev_pos(0) Z=$mom_prev_pos(2)"
#  MOM_force ONCE K
#  MOM_do_template thread_move_P3
#
#  }

}


#=============================================================
proc MOM_start_of_thread { } { return }
#=============================================================
proc MOM_end_of_thread  { } { return }
#=============================================================
proc MOM_lathe_thread { } {
#=============================================================
  global cycle_name
  global cycle_init_flag
  set cycle_init_flag TRUE
  set cycle_name LATHE_THREAD
}


#=============================================================
proc  MOM_lathe_thread_move { } {
#=============================================================
global mom_machine_control_use_machine_cycle

if {[info exists mom_machine_control_additional_commands]==0} { set  mom_machine_control_additional_commands  "" ; }

if {[info exists mom_machine_control_additional_commands]} {

  global cycle_init_flag

  global mom_lathe_thread_type mom_lathe_thread_advance_type
  global mom_lathe_thread_lead_i mom_lathe_thread_lead_k
  global mom_motion_distance
  global mom_lathe_thread_increment mom_lathe_thread_value
  global thread_type thread_increment feed_rate_mode
  switch $mom_lathe_thread_advance_type {
    1  {set thread_type CONSTANT ; MOM_suppress once E}
    2  {set thread_type INCREASING ; MOM_force once E}
    default {set thread_type DECREASING ; MOM_force once E}
  }
  if {$thread_type == "INCREASING" || $thread_type == "DECREASING"} {
    if {$mom_lathe_thread_type !=1  } {
      set LENGTH $mom_motion_distance
      set LEAD $mom_lathe_thread_value
      set INCR $mom_lathe_thread_increment
      set E [expr abs(pow(($LEAD + ($INCR * $LENGTH)) , 2) - pow($LEAD , 2)) / 2 * $LENGTH]
      set thread_increment $E
    }
  }
  if {$mom_lathe_thread_lead_i == 0} {
    MOM_suppress once I ; MOM_force once K
  } elseif {$mom_lathe_thread_lead_k == 0} {
    MOM_suppress once K ; MOM_force once I
  } else {
    MOM_force once I ; MOM_force once K
  }

  global mom_kin_rapid_feed_rate   mom_feed_rate   feed  mom_programmed_feed_rate
  if {$mom_programmed_feed_rate == 0.0 || $mom_feed_rate >= $mom_kin_rapid_feed_rate } { MOM_suppress Once F  G_feed  }

  PB_feed

  MOM_suppress ONCE   Text_ldr   Text_m45   Text_p45  X  Z   Text_incr   Text_trlr

  global TextIncr
  if {[info exists mom_machine_control_additional_commands]} {
       if {"$mom_machine_control_additional_commands" ==  "$TextIncr" } { MOM_force ONCE  Text_incr ;  }
  }

  MOM_force once G ;
  MOM_do_template cycle_thread_move_G
  MOM_force ONCE X Text_trlr;
  MOM_do_template thread_move_X
  MOM_force ONCE Z Text_trlr;
  MOM_do_template thread_move_Z
  MOM_force ONCE  StepThreadF  ;
  MOM_do_template  thread_move_F

  global mom_prev_pos mom_pos
  global varP3
  set  varP3 [expr {$mom_pos(0)==$mom_prev_pos(0) ?0: [ expr ($mom_pos(0)-$mom_prev_pos(0))] } ]
  set varP3 0.0

  MOM_force ONCE I
  MOM_do_template thread_move_P1
  MOM_force ONCE K
  MOM_do_template thread_move_P2

  MOM_force ONCE K
  MOM_do_template thread_move_P3

#  MOM_force once G_motion ; #MOM_force_block Once thread_move_G
#  MOM_do_template thread_move_G
#  MOM_force ONCE X Text_trlr;
#  MOM_do_template moveX
#  MOM_force ONCE Z Text_trlr;
#  MOM_do_template moveZ
#  MOM_force ONCE StepThreadF;
#  MOM_do_template  thread_move_F_nogroup

 }

}


#=============================================================
proc MOM_drill_deep { } {
#=============================================================
  global cycle_name
  set cycle_name DRILL_DEEP
}


#=============================================================
proc  MOM_drill_deep_move { } {
#=============================================================
  global cycle_name  TextTrlr
  global mom_pos mom_prev_pos    mom_motion_distance  feed

  MOM_force Once cycle_step F_Multi Text_trlr

  MOM_do_template feed_G
  if { [expr abs($mom_pos(2)-$mom_prev_pos(2))]<=0.00001 } {
	MOM_output_literal "G72$TextTrlr"
	MOM_force once X ;
	MOM_do_template cycle_drill_deep_X ;
	MOM_do_template multiF
	MOM_do_template cycle_drill_deep_Step_x
 } else {
	MOM_output_literal "G73$TextTrlr"
	MOM_force once Z ;
	MOM_do_template cycle_drill_deep_Z  ;
  	#if {$feed==$tmp_feed} { MOM_force OFF Text_trlr; }
   	MOM_do_template multiF
   	MOM_do_template cycle_drill_deep_Step_z
 }

}


#=======================================
set  maxEnd  0; set maxFeed  0.0;  set fl 0 ; set  maxPoint 0; set  t2 0;
#=======================================

#=============================================================
proc MOM_cdrill { } {
#=============================================================
  global cycle_name  cycle_init_flag
  set cycle_init_flag TRUE  ;   set cycle_name CDRILL
  global maxEnd  maxFeed  maxPoint
  set  maxEnd  0.0; set maxFeed  0.0;
}

#=============================================================
proc  MOM_cdrill_move { } {
#=============================================================
 global mom_cycle_feed_to_pos  mom_template_subtype
 global maxEnd  maxFeed  maxPoint  t2
  set t1 [expr abs($maxEnd) ] ; set maxPoint  $t2 ;
  set t1 [expr abs($maxEnd) ] ; set maxPoint  $t2 ; set t2 $mom_cycle_feed_to_pos(0);
  if {$t1<=[expr abs($mom_cycle_feed_to_pos(0)) ] } { set maxEnd $mom_cycle_feed_to_pos(0) ; }

# set t2 [expr abs($mom_cycle_feed_to_pos(0)) ] ; if {$t1<=$t2 } { set maxEnd $mom_cycle_feed_to_pos(0) ; }
#  global mom_programmed_feed_rate  feed  ;  if {$maxFeed==0} { set maxFeed  $mom_programmed_feed_rate ;}

}

#=============================================================
proc MOM_cdrill_peck { } {
#=============================================================
  global cycle_name  cycle_init_flag
  set cycle_name CDRILL_PECK
  global maxEnd  maxFeed
  set  maxEnd  0.0; set maxFeed  0.0;
}

#=============================================================
proc  MOM_cdrill_peck_move { } {
#=============================================================
 global mom_cycle_feed_to_pos
 global maxEnd  maxFeed   maxPoint   t2
  set t1 [expr abs($maxEnd) ] ;   set   maxPoint  $t2 ; set t2 $mom_cycle_feed_to_pos(0);
  if {$t1<=[expr abs($mom_cycle_feed_to_pos(0)) ] } { set maxEnd $mom_cycle_feed_to_pos(0) ; }
}

#=============================================================
proc MOM_cdrill_break_chip { } {
#=============================================================
  global cycle_name  cycle_init_flag
  set cycle_name CDRILL_BREAK_CHIP
  global maxEnd  maxFeed
  set  maxEnd  0.0; set maxFeed  0.0; set fl 0 ;
}

#=============================================================
proc  MOM_cdrill_break_chip_move { } {
#=============================================================
 global mom_cycle_feed_to_pos
 global maxEnd  maxFeed  maxPoint   t2
 set t1 [expr abs($maxEnd) ] ; set maxPoint  $t2 ; set t2 $mom_cycle_feed_to_pos(0);
 if {$t1<=[expr abs($mom_cycle_feed_to_pos(0)) ] } { set maxEnd $mom_cycle_feed_to_pos(0) ; }
}

#=============================================================
proc checkout { varStr adr } {
#=============================================================
if {$adr==""} { return ""; }
 switch $adr {
  "P"  { set w__word_sym  "(P)(\[0-9\])+" ; }
  "T"  { set w__word_sym  "(T)(\[0-9\])+" ; }
  "G"  { set w__word_sym  "(G)(\[0-9\])+" ; }
  "F"  { set w__word_sym  "(F)(\[0-9\])+" ; }
  "M"  { set w__word_sym  "(M)(\[0-9\])+" ; }
  "X"  { set w__word_sym  "(X)(\[- - +\])*(\[0-9\])+" ; }
  "Z"  { set w__word_sym  "(Z)(\[- - +\])*(\[0-9\])+" ; }
  default { ; }
}
set var0  "" ;set var10 0 ;
set fl1 [regexp -nocase  -- "$w__word_sym"  $varStr   var0 ]
if  {($fl1==0) } {  return "" ; }
return $varStr ;
}

#===================================================
proc MOM_cycle_off { } {
#=============================================================
  global cycle_name   maxEnd    maxFeed    maxPoint
  global TextTrlr

  global mom_prev_pos
  global mom_operation_type   mom_template_subtype

  global mom_center_drill_total_depth   mom_constant_increment

  global mom_feed_cut_value mom_feed_cut_unit
  global mom_kin_rapid_feed_rate   feed  mom_feed_rate_mode  mom_feed_rate
  global mom_programmed_feed_rate

  if  {$mom_operation_type=="Turn Centerline Drilling"} {
   if {$mom_feed_cut_value!=0 && $mom_feed_cut_value<$mom_kin_rapid_feed_rate} {

       set  TMPfeed   [expr $mom_feed_cut_value*100.0]
       if {$TMPfeed > 9999.99 } { set feed $mom_feed_cut_value ; } else { set feed  $TMPfeed ; }

   } else { set mom_feed_cut_value 100; set mom_feed_cut_unit "mmpr" ;  set feed $mom_feed_cut_value ; }

   MOM_do_template feed_G
   # if {$mom_feed_cut_unit== "mmpr"} { MOM_output_literal "G95" ; } else { MOM_output_literal "G94" ; }

   MOM_force once Text_trlr  Z  K;
   if {$cycle_name=="CDRILL"} {
     if {$mom_template_subtype=="CENTERLINE_TAPPING"} {

      global TextIncr  TextTrlr
      global mom_machine_control_additional_commands
      set tmpstr ""
      if {[info exists mom_machine_control_additional_commands]} {
        if {"$mom_machine_control_additional_commands" ==  "$TextIncr" } { set tmpstr $TextIncr }
       }
      append tmpstr "G33$TextTrlr"
      MOM_output_literal "$tmpstr";

      MOM_do_template cycle_cdrill_z
      MOM_suppress  Once Text_trlr
      MOM_force Once F_Multi
      MOM_do_template multiF

    } else {

     MOM_output_literal "G73$TextTrlr"
     MOM_do_template cycle_cdrill_z
     set tm [ checkout [ MOM_do_template multiF CREATE] "F" ]
     if {$tm!=""} { MOM_output_literal "$tm" }
     set mom_constant_increment  $mom_center_drill_total_depth
     MOM_do_template cycle_cdrill_P

    }
  }

  if {$cycle_name=="CDRILL_BREAK_CHIP"} {
    MOM_output_literal "G73$TextTrlr"
    MOM_do_template cycle_cdrill_z
    MOM_do_template multiF
    MOM_do_template cycle_cdrill_P
  }

  if {$cycle_name=="CDRILL_PECK"} {
    MOM_output_literal "G73$TextTrlr"
    global t2
    ;#MOM_output_literal "maxEnd ==$maxEnd maxPoint=$maxPoint   t2=$t2"
    MOM_do_template cycle_cdrill_z
    set tm [ checkout [ MOM_do_template multiF CREATE] "F" ]
    if {$tm!=""} { MOM_output_literal "$tm" }
    MOM_do_template cycle_cdrill_P
  }

  global dwell_output G4 P4
  if {$dwell_output==1} {
    set  dwell_output 0
    MOM_output_literal $G4
    MOM_output_literal $P4
   }

}

set  cycle_name "NONE";
}

#=============================================================
proc MOM_cycle_plane_change { } {
#=============================================================
}


############## EVENT HANDLING SECTION ################

#=1============================================================
proc MOM_start_of_program { } {
# This procedure is executed at the very begining of the program.
# It gets called before any command is read from the task file.
#=============================================================
  global mom_logname mom_date is_from
  global mom_coolant_status mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register mom_wire_cutcom_adjust_register

#---- Unsetting default setting for variables

    set pb_start_of_program_flag 0
    set mom_coolant_status UNDEFINED
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}

    global is_from ; set is_from ""

  OPEN_files ; #open warning and listing files
  LIST_FILE_HEADER ; #list header in commentary listing

  global mom_sys_post_initialized
  if { $mom_sys_post_initialized > 1 } { return }


#************
uplevel #0 {


#=============================================================
proc MOM_set_csys {} {
#=============================================================
  if [llength [info commands PB_CMD_kin_set_csys] ] {
    PB_CMD_kin_set_csys
  }
}


#=============================================================
proc MOM_msys {} {
#=============================================================
}

  incr mom_sys_post_initialized

} ;# uplevel
#***********

}

#=============================================================
proc MOM_end_of_program { } {
#=============================================================
   global mom_part_name
   global mom_sys_end_of_program_code   mom_sys_rewind_code
   global mom_machine_time
   global mom_coolant_status
   global mom_spindle_status

  if {$mom_spindle_status!="OFF"} { MOM_spindle_off; }
  if {$mom_coolant_status!="OFF"} { MOM_coolant_off; }

  MOM_output_literal "M$mom_sys_rewind_code"
  MOM_set_seq_off

  global TIME
  global mom_machine_time
  set mom_machine_time [ expr ($TIME*1.10) ]
  set str0 "[format "%.2f" $mom_machine_time ] min"
  set str1 "\n    =$str0"
  set str2 [ outTime $mom_machine_time ]
  MOM_output_to_listing_device "$str1  $str2 \n"

  LIST_FILE_TRAILER ; #**** The following procedure lists the tool  list with time in commentary data
  CLOSE_files       ; #**** The following procedure closes the warning and listing files
}


#=============================================================
proc PB_CMD_set_lathe_arc_plane { } {
#=============================================================
# This custom command will switch the valid arc plane for lathes
# from XY to ZX when the users selects the ZX lathe work
# plane in the MCS dialog.  If this custom command is not used then
# all arcs will be output as linear moves when the user selects the
# ZX Plane.
#
# Post Builder v3.0.1 executes this custom command automatically
# for all lathe posts.

  global mom_lathe_spindle_axis
  global mom_kin_arc_valid_plane

   if { [info exists mom_lathe_spindle_axis] && $mom_lathe_spindle_axis == "MCSZ" } {
      set mom_kin_arc_valid_plane  "ZX"
      MOM_reload_kinematics
   }
}


#=============================================================
proc PB_start_of_program { } {
#=============================================================
 if [llength [info commands PB_CMD_kin_start_of_program] ] { PB_CMD_kin_start_of_program }

  global mom_warning_info
  set mom_warning_info "\n   ' -31'."
  MOM_output_to_listing_device $mom_warning_info  ;  # MOM_catch_warning ;

#  set mom_warning_info "\n!      :\n"
#  append mom_warning_info "\t \{~\} Z\n"
#  append mom_warning_info "\t \{~\} X"
#  MOM_output_to_listing_device $mom_warning_info  ;  #  MOM_catch_warning ;

  MOM_force once M_spindle S_SMM G G_spin
  MOM_output_literal "M40" ; #  

}

#=============================================================
proc PB_CMD_machine_mode { } {
#=============================================================
  global mom_output_mode mom_arc_mode mom_prev_machine_mode mom_machine_mode mom_feed_set_mode
  set mom_output_mode     	"ABSOLUTE"
  set mom_prev_machine_mode  	"TURN"
  set mom_machine_mode  	"TURN"
  set mom_arc_mode     		"CIRCULAR"
  set mom_feed_set_mode 	"MMPR"
}

#=2============================================================
proc MOM_machine_mode { } {
#=============================================================
 global mom_output_mode mom_arc_mode mom_machine_mode mom_feed_set_mode
 catch {PB_CMD_machine_mode} errMes ; MOM_log_message "$errMes" ;
 global pb_start_of_program_flag
 if {$pb_start_of_program_flag == 0} {PB_start_of_program ; set pb_start_of_program_flag 1}
}


#=3============================================================
proc MOM_start_of_path { } {
# This procedure is executed at the begining of each path in the task
# It gets called after all the general parameters of the path are loaded  like the path name and the tool name.
#=============================================================
  global mom_path_name mom_tool_name

  global  var_start_of_path_num ;incr var_start_of_path_num ; #   
  global lathe_num_cut ; set lathe_num_cut 0;

  TOOL_SET MOM_start_of_path
}


#=======6===============
proc MOM_from_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev  mom_motion_type mom_kin_max_fpm
  global mom_from_pos mom_pos  mom_prev_pos

}


#=============================================================
proc MOM_initial_move { } {
#__ This procedure is executed for the initial move of each operation.  It
#___assumes the tool is moving from a safe position at rapid to the start of  the operation.
#=============================================================
  catch { COOLANT_SET ; SPINDLE_SET ; RAPID_SET ; TOOL_SET }

  MOM_do_template spindle_on

  global mom_coolant_status
  global  var_start_of_path_num
  if {$var_start_of_path_num==1} {
     set mom_coolant_status "ON"
     MOM_do_template coolant_on
  }

  MOM_spindle_rpm
  MOM_coolant_on
  PB_condition_move

}


#=============================================================
proc MOM_first_move { } {
#=============================================================
  global mom_motion_type
  catch { SPINDLE_SET ; RAPID_SET ; }
  PB_condition_move ;
}


#=============================================================
proc MOM_return_move { } {
#=============================================================
  PB_return_event
}


#=============================================================
proc MOM_gohome_move { } {
#=============================================================
  PB_return_event
}


#=============================================================
proc MOM_end_of_path { } {
#=============================================================
}


#=============================================================
proc MOM_linear_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev  feed  mom_kin_rapid_feed_rate
  global mom_feed_set_mode
  global mom_motion_type mom_motion_event
  global mom_pos mom_prev_pos

#
  if {$mom_motion_event == "rapid_move"} {MOM_rapid_move ;   return ; }
#
 PB_feed

  set mp(0) [ format "%-.7f" $mom_pos(0) ]
  set mp(2) [ format "%-.7f" $mom_pos(2) ]

  set mpp(0) [ format "%-.7f" $mom_prev_pos(0) ]
  set mpp(2) [ format "%-.7f" $mom_prev_pos(2) ]

  global  tx  tz  txd tzd
  set txd  [expr ($mp(0)-$mpp(0))]
  set tzd  [expr ($mp(2)-$mpp(2))]
  set tx [expr (abs($txd))]
  set tz [expr (abs($tzd))]

  set ds  [expr abs($tx-$tz)]

  MOM_suppress ONCE  Text_ldr   Text_m45   Text_p45  X  Z   Text_incr   Text_trlr

 if {$tx<=0.0001} {
  MOM_force once  Z ; MOM_do_template moveZ
 } elseif {$tz<=0.0001} {
     MOM_force once  X ; MOM_do_template moveX
    } else {

     ; #  X +45; X -45;
     if {$ds<=0.0001} {

      #MOM_output_to_listing_device "txd=$txd"
      #MOM_output_to_listing_device "tzd=$tzd"
      #MOM_output_to_listing_device "tx=$tx"
      #MOM_output_to_listing_device "tz=$tz"
      #MOM_output_to_listing_device "ds=$ds"
      #
      #MOM_output_to_listing_device "-------"

      if { $tzd >=  0.0001 } {
          if { $txd >= 0.0001 }  {
             ; #  X +45
             MOM_force once X Text_p45 ; MOM_do_template moveX ;  return
            } else  {
             ; #  X +45
             MOM_force once X Text_p45 ; MOM_do_template moveX ; return
           }
        } else {
           if { $txd >= 0.0001 }  {
              ; #  X -45
              MOM_force once X  Text_m45;  MOM_do_template moveX ;  return
             } else {
              ; #  X -45
              MOM_force once X  Text_m45; MOM_do_template moveX ;  return
           }
       }

     }

     MOM_force once X Z
     ; # 1 - [X* z];
     MOM_force once X  Z Text_trlr
     MOM_do_template moveX
     MOM_suppress ONCE  Text_ldr   Text_m45   Text_p45  Text_incr   Text_trlr
     MOM_do_template moveZ

    }


}


#=============================================================
proc MOM_circular_move { } {
#=============================================================
   global mom_sys_circle_code
   global mom_pos mom_prev_pos  mom_pos_arc_center
   global mom_arc_direction mom_arc_angle
   global mom_sys_lathe_x_factor mom_sys_lathe_z_factor
   global tx tz TextTrlr

   PB_feed

  set mp(0) [ format "%-.7f" $mom_pos(0) ]
  set mp(2) [ format "%-.7f" $mom_pos(2) ]

  set mpp(0) [ format "%-.7f" $mom_prev_pos(0) ]
  set mpp(2) [ format "%-.7f" $mom_prev_pos(2) ]

  set txd  [expr ($mp(0)-$mpp(0))]
  set tzd  [expr ($mp(2)-$mpp(2))]
  set tx [expr (abs($txd))]
  set tz [expr (abs($tzd))]

  MOM_suppress ALWAYS  Text_ldr   Text_m45   Text_p45  X  Z   Text_incr   Text_trlr

  set ang [ format "%-.6f" $mom_arc_angle ]

  if {[ EQ_is_ge $ang 89.98 ]} {

	set mom_sys_circle_code(CLW)                "13"
  	set mom_sys_circle_code(CCLW)               "12"
	MOM_force Once G_motion ; MOM_do_template circular_move_block_G
 	MOM_force once X  Z  Text_trlr
 	MOM_do_template moveX
 	MOM_do_template moveZ
	set mom_sys_circle_code(CLW)                "3"
  	set mom_sys_circle_code(CCLW)               "2"

   } else {

	set tx [expr (abs($mom_sys_lathe_x_factor))]
	#MOM_force Once I K G_motion
	MOM_force Once G_motion ; MOM_do_template circular_move_block_G
	MOM_force once X Text_trlr ; MOM_do_template moveX
	MOM_force once Z Text_trlr ; MOM_do_template moveZ
	#MOM_do_template multiF
	MOM_force Once I
	MOM_do_template circular_move_block_I_sign
	MOM_force Once K
	MOM_do_template circular_move_block_K

  }

}



#=============================================================
proc MOM_rapid_move { } {
#=============================================================
 global mom_cycle_spindle_axis
 global mom_pos mom_prev_pos

  set mp(0) [ format "%-.7f" $mom_pos(0) ]
  set mp(2) [ format "%-.7f" $mom_pos(2) ]

  set mpp(0) [ format "%-.7f" $mom_prev_pos(0) ]
  set mpp(2) [ format "%-.7f" $mom_prev_pos(2) ]

  set txd  [expr ($mp(0)-$mpp(0))]
  set tzd  [expr ($mp(2)-$mpp(2))]
  set tx [expr (abs($txd))]
  set tz [expr (abs($tzd))]

# set fl [expr  ( [ EQ_is_zero $tx ] + [ EQ_is_zero $tz ] ) ]
# if {$fl<2} {

  RAPID_SET
  MOM_suppress ONCE   Text_ldr   Text_m45   Text_p45  X  Z   Text_incr   Text_trlr
  if { [ EQ_is_zero $txd ] } {
    MOM_force once Text_ldr Z ; MOM_do_template moveZ
   } elseif { [ EQ_is_zero $tzd ] } {
     MOM_force once Text_ldr X;  MOM_do_template moveX
        } else {
         MOM_force once X Z
         global var_rapid_move_condition
         ; # 1 - [~X* Z]; 2 - [~Z ~x];
         switch $var_rapid_move_condition {
          1 {
             MOM_suppress ONCE Text_ldr Text_m45 Text_p45 Text_incr Text_trlr
             MOM_force once Text_ldr Text_trlr
             MOM_do_template moveX
             MOM_suppress ONCE Text_m45 Text_p45 Text_incr
             MOM_do_template moveZ ;
            }
          2 {
             MOM_suppress ONCE Text_m45 Text_p45 Text_incr Text_trlr
             MOM_force once Text_ldr ;
             MOM_do_template moveZ ;
             MOM_suppress ONCE Text_m45 Text_p45 Text_incr Text_trlr
             MOM_force once Text_ldr
             MOM_do_template moveX ;
            }
         }
       }
#  }

}


#=============================================================
proc PB_CMD_load_tools { } {
#C 
#=============================================================
  global mom_tool_change_type mom_manual_tool_change mom_tool_text
  global mom_motion_event  mom_cycle_spindle_axis
  global mom_from_pos mom_pos  mom_prev_pos

  global change_tool_feed

  if {[info exists mom_tool_change_type]} {
    switch $mom_tool_change_type {
         MANUAL { MOM_do_template stop }
         AUTO   {
                  MOM_suppress ONCE Text
                  if {[info exists mom_tool_text]} {
                       if {$mom_tool_text != ""} { MOM_force Once Text }
                    }
                  MOM_force Once T  ; MOM_do_template  load_tool ; MOM_do_template load_tool_text ;
                  set change_tool_feed 1

                }
    }
  } elseif {[info exists mom_manual_tool_change]} {
     if {$mom_manual_tool_change == "TRUE"} { MOM_do_template stop }
    }
}


#=============================================================
proc MOM_first_tool { } {
#=============================================================
 global mom_tool_change_type mom_manual_tool_change
 global mom_update_post_cmds_from_tool

 global  first_tool ;set first_tool 1 ; #  1- 

  if {[info exists mom_update_post_cmds_from_tool]} {
    switch $mom_update_post_cmds_from_tool {
      0 { ; }
      default {  PB_CMD_load_tools ; }
     }
   }

}

#=============================================================
proc MOM_tool_change { } {
# This procedure is executed at any time there is a tool change.
# It gets called after the tool change data is loaded like the tool number
# and the register numbers.
#=============================================================
 global mom_tool_change_type mom_manual_tool_change
 global mom_update_post_cmds_from_tool

  if {[info exists mom_update_post_cmds_from_tool]} {
    switch $mom_update_post_cmds_from_tool {
      0 { ; }
      default {  PB_CMD_load_tools ;  }
     }
   }

}

#=============================================================
proc MOM_load_tool { } {
# This procedure is executed for the LOAD/TOOL command.  All output for the LOAD
# command will take place with the initial move.
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
  global mom_update_post_cmds_from_tool

  if {[info exists mom_update_post_cmds_from_tool]} {
   switch $mom_update_post_cmds_from_tool {
     0 { PB_CMD_load_tools ; }
     default { ; }
     }
   }

}

#=============================================================
proc MOM_length_compensation { } {
#=============================================================
  global mom_warning_info
  set mom_warning_info "WARNING:      '31'   \[ length_compensation\]"
  MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;
}

#=============================================================
proc MOM_tool_preselect { } {
# This procedure is executed when the Tool Preselect command is activated.
#=============================================================
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
  global mom_warning_info
  set mom_warning_info "WARNING:     '31'   \[ tool_preselect\]"
  MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;
}


#============================================================= 
proc  MOM_coolant_on {} {
# __This procedure is executed when the Coolant command is activated.
#=============================================================
    global mom_coolant_mode mom_coolant_status
	COOLANT_SET
#..__.BUG: mom_coolant_mode default value is not getting set.
#          So ... setting the default value here.
    if {$mom_coolant_status == "ON"} { set mom_coolant_mode FLOOD }
    set mom_coolant_status $mom_coolant_mode
    MOM_do_template coolant_on
}

#=============================================================
proc  MOM_coolant_off {} {
#__ This procedure is executed when the Coolant command is deactivated.
#=============================================================
  global mom_coolant_mode mom_coolant_status
  COOLANT_SET
  if {$mom_coolant_status != "OFF"} { set mom_coolant_mode OFF }
  set mom_coolant_status $mom_coolant_mode
  MOM_do_template coolant_off
}

#============================================================= 
proc MOM_spindle_rpm { } {
# This procedure is executed when the Spindle command is activated.
#=============================================================
  global mom_spindle_mode mom_spindle_status
  global mom_spindle_range  mom_spindle_rpm  mom_spindle_maximum_rpm  mom_surface_speed
  global mom_spindle_speed_defined
  global mom_spindle_speed

  SPINDLE_SET
  set mom_spindle_status $mom_spindle_mode

set Range1(11) 12.5; set Range1(12)   18;   set Range1(13)    25;  set Range1(14) 35.5;  set Range1(15)   50;
set Range1(16)   71; set Range1(17)  100;   set Range1(18)   140;  set Range1(19)  200;
set Range2(21)   50; set Range2(22)   71;   set Range2(23)   100;  set Range2(24)  140;  set Range2(25)  200;
set Range2(26)  280; set Range2(27)  400;   set Range2(28)   560;  set Range2(29)  800;
set Range3(41)  125; set Range3(42)  180;   set Range3(43)   250;  set Range3(44)   355; set Range3(45)  500;
set Range3(46)  710; set Range3(47) 1000;   set Range3(48)  1400; set Range3(49)  2000;

 #MOM_output_literal "$mom_spindle_mode  $mom_spindle_rpm   $mom_spindle_speed  $mom_surface_speed"

 if {$mom_spindle_mode == "SFM" || $mom_spindle_mode == "SMM"} { MOM_spindle_css ; return ; }

 if {$mom_spindle_mode=="RPM"} {
    set mom_spindle_speed  $mom_spindle_rpm
    MOM_do_template spindle_on
    MOM_do_template spindle_rpm_range
    global output_G97   # G97
    if {$output_G97==1} {
    	MOM_do_template spindle_rpm_G
    	set output_G97 0
    }
    MOM_do_template spindle_rpm
   }

}

set mom_spindle_minimum_rpm  0

#=============================================================
proc MOM_spindle_css { } {
# This procedure is executed when the Spindle command is activated SFM/SMM mode.
#=============================================================

  global mom_spindle_mode  mom_spindle_speed   mom_spindle_rpm
  global mom_spindle_status mom_spindle_mode
#
global mom_spindle_minimum_rpm
#
 set mom_spindle_status $mom_spindle_mode
 if {$mom_spindle_mode == "SFM" || $mom_spindle_mode == "SMM"} {
    SPINDLE_SET
    MOM_force once G_spin
    MOM_do_template spindle_css_G
    MOM_do_template spindle_css_Pmax
    MOM_do_template spindle_css_Pmin
    MOM_force once S_SMM
    MOM_do_template spindle_css
    global output_G97
    set output_G97 1
  } else {
     global mom_warning_info
     set mom_warning_info "!    "
     MOM_output_to_listing_device $mom_warning_info ;  MOM_catch_warning ;
   }
}

#=============================================================
proc MOM_spindle_off { } {
# This procedure is executed when the Spindle command is deactivated.
#=============================================================
  global mom_spindle_status  mom_spindle_mode
  global  mom_spindle_speed   mom_spindle_rpm
  SPINDLE_SET
  set mom_spindle_status $mom_spindle_mode
  set mom_spindle_speed   0  ;
  set mom_spindle_rpm    0.0 ;
  MOM_do_template spindle_off
}


#=============================================================
proc MOM_delay { } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time
  #__post builder provided format for the current mode:
  if {[info exists mom_sys_delay_param(${mom_delay_mode},FORMAT)] != 0} {
    MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},FORMAT)
  }
  switch $mom_delay_mode {
    SECONDS {set delay_time $mom_delay_value}
    default {
             set delay_time $mom_delay_revs
             global  mom_warning_info
             set mom_warning_info "!       ."
             MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
            }
  }
  set delay_time  [expr ($delay_time / 0.01) ]

  global cycle_name
  global dwell_output G4 P4
  set tmpCreate  "" ;
  if {[info exists cycle_name ]!= 0} {
    if {$cycle_name!="NONE"} { set tmpCreate "CREATE" ; set dwell_output 1 }
  }

  set G4 [ MOM_do_template delay_G $tmpCreate ]
  set P4 [ MOM_do_template delay_P $tmpCreate ]
}


#=============================================================
proc MOM_origin {} {
#=============================================================
 global mom_origin_point ;
  MOM_force Once G Text_trlr ;   MOM_do_template coordinate_system_G
 if {$mom_origin_point=="ABSOLUTE"}  {   MOM_suppress  Once  Text_incr  ; }
        #INCREMENT
  MOM_force Once X Text_trlr ;
  MOM_do_template coordinate_system_X
  MOM_force Once Z   Text_incr   ;
  if {$mom_origin_point=="ABSOLUTE"}  {   MOM_suppress  Once  Text_incr  ; }
  MOM_do_template coordinate_system_Z
}


#=============================================================
proc MODES_SET { } {
#=============================================================
   global mom_machine_mode  mom_feed_set_mode  mom_feed_rate_output_mode
   global mom_output_mode  mom_arc_mode
   global mom_parallel_to_axis  mom_modes_text
   global mom_warning_info

; # "ABSOLUTE", "INCREMENTAL"
  switch $mom_output_mode {
    ABSOLUTE { set isincr OFF }
    default  { set isincr ON }
  }
  MOM_incremental $isincr X Z

; # "LINEAR", "CIRCULAR"
  if {$mom_arc_mode == "LINEAR"} {
  } elseif {$mom_arc_mode == "CIRCULAR"} {
  }

# "OFF", "IPM", "IPR", "MMPM", "MMPR", "INVERSE"
  switch $mom_feed_rate_output_mode {
    MMPR { ; }
    OFF  { ; }
    default  { ; }
  }

# "ZAXIS", "WAXIS", "UAXIS"
  switch $mom_parallel_to_axis {
    ZAXIS { ; }
    default  {
       set mom_warning_info "WARNING:     Z (    Z)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set mom_parallel_to_axis  "ZAXIS"
     }
  }

# "MILL", "TURN", "PUNCH", "LASER", "TORCH", "WIRE"
  switch $mom_machine_mode {
    TURN { ; }
    default  {
       set mom_warning_info "WARNING:        1620 (    TURN)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set  mom_machine_mode  "TURN"
     }
  }

}

#=============================================================
proc MOM_set_modes { } {
#=============================================================
# This procedure is executed for the Set Mode command.
   MODES_SET
}


#=============================================================
proc MOM_auxfun { } {
#=============================================================
  global mom_auxfun_text
  MOM_suppress once Text
  if {[info exists  mom_auxfun_text]} {
    if {$mom_auxfun_text != ""} { MOM_force  once  Text }
   }
  MOM_do_template auxfun
  MOM_do_template auxfun_text
}

#=============================================================
proc MOM_prefun { } {
#=============================================================
  global mom_prefun_text
  MOM_suppress once Text
  if {[info exists  mom_prefun_text]} {
     if {$mom_prefun_text != ""} { MOM_force  once  Text }
     }
  MOM_do_template prefun
  MOM_do_template prefun_text
}

#=============================================================
proc MOM_stop { } {
#__ This procedure is executed when the Program Stop command is activated.
#=============================================================
  MOM_force ONCE M
  MOM_do_template stop
}

#=============================================================
proc  MOM_opstop { } {
#___ This procedure is executed when the Optional Stop command is activated.
#=============================================================
    MOM_force ONCE M
    MOM_do_template opstop
}

#=============================================================
proc  MOM_operator_message {} {
#_____ This procedure is executed when the Operator Message command is activated.
#=============================================================
  global mom_operator_message  mom_operator_message_defined
  MOM_output_literal "G55"
}

#=============================================================
proc  MOM_pprint {} {
#___ This procedure is executed when the Pprint command is activated.
#=============================================================
 global mom_pprint
 global mom_warning_info
 set mom_warning_info "!      '-31' "
 MOM_output_to_listing_device $mom_warning_info ; MOM_catch_warning ;
 MOM_output_text "($mom_pprint)"
}

#=============================================================
proc MOM_cutcom_on { } {
#=============================================================
}

#=============================================================
proc MOM_cutcom_off { } {
#=============================================================
}

#=============================================================
proc PB_CMD_set_csys { } {
#=============================================================
#  This custom command is provided as the default to nullify
#  the same command in a linked post that may have been
#  imported from pb_cmd_coordinate_system_rotation.tcl.
}

#=============================================================
proc PB_CMD_kin_start_of_program { } {
#=============================================================
#
#  This procedure will execute the following custom commands for
#  initialization.  They will be executed once at the start of
#  program and again each time they are loaded as a linked post.
#  After execution they will be deleted so that they are not
#  present when a different post is loaded.  You may add a call
#  to a procedure that you want executed when a linked post is
#  loaded.
#
#  Note that when a linked post is called in, the Start of Program
#  event marker is not executed again, only this procedure.
#
#  DO NOT REMOVE ANY LINES FROM THIS PROCEDURE UNLESS YOU KNOW
#  WHAT YOU ARE DOING.  DO NOT CALL THIS PROCEDURE FROM ANY
#  OTHER CUSTOM COMMAND.
#

   set command_list [list]

   lappend command_list  PB_CMD_initialize_tool_list
   lappend command_list  PB_CMD_init_tool_list
   lappend command_list  PB_CMD_init_tape_break
   lappend command_list  PB_CMD_set_lathe_arc_plane


   foreach cmd $command_list {
      if [llength [info commands "$cmd"]] {
         $cmd
         rename $cmd ""
         proc $cmd { args } {}
      }
   }
}


#=============================================================
proc PB_CMD_set_lathe_arc_plane { } {
#=============================================================
# This custom command will switch the valid arc plane for lathes
# from XY to ZX when the users selects the ZX lathe work
# plane in the MCS dialog.  If this custom command is not used then
# all arcs will be output as linear moves when the user selects the
# ZX Plane.
#
# Post Builder v3.0.1 executes this custom command automatically
# for all lathe posts.

  global mom_lathe_spindle_axis
  global mom_kin_arc_valid_plane

   if { [info exists mom_lathe_spindle_axis] && $mom_lathe_spindle_axis == "MCSZ" } {
      set mom_kin_arc_valid_plane  "ZX"
      MOM_reload_kinematics
   }
}



if [info exists mom_sys_start_of_program_flag] {
   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }
} else {
   set mom_sys_head_change_init_program 1
   set mom_sys_start_of_program_flag 1
}
